const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ReviewsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const reviews = await db.reviews.create(
      {
        id: data.id || undefined,

        comments: data.comments || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await reviews.setReview_cycle(data.review_cycle || null, {
      transaction,
    });

    await reviews.setEmployee(data.employee || null, {
      transaction,
    });

    await reviews.setReviewer(data.reviewer || null, {
      transaction,
    });

    await reviews.setOrganizations(data.organizations || null, {
      transaction,
    });

    return reviews;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const reviewsData = data.map((item, index) => ({
      id: item.id || undefined,

      comments: item.comments || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const reviews = await db.reviews.bulkCreate(reviewsData, { transaction });

    // For each item created, replace relation files

    return reviews;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const reviews = await db.reviews.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.comments !== undefined) updatePayload.comments = data.comments;

    updatePayload.updatedById = currentUser.id;

    await reviews.update(updatePayload, { transaction });

    if (data.review_cycle !== undefined) {
      await reviews.setReview_cycle(
        data.review_cycle,

        { transaction },
      );
    }

    if (data.employee !== undefined) {
      await reviews.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.reviewer !== undefined) {
      await reviews.setReviewer(
        data.reviewer,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await reviews.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return reviews;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const reviews = await db.reviews.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of reviews) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of reviews) {
        await record.destroy({ transaction });
      }
    });

    return reviews;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const reviews = await db.reviews.findByPk(id, options);

    await reviews.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await reviews.destroy({
      transaction,
    });

    return reviews;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const reviews = await db.reviews.findOne({ where }, { transaction });

    if (!reviews) {
      return reviews;
    }

    const output = reviews.get({ plain: true });

    output.review_cycle = await reviews.getReview_cycle({
      transaction,
    });

    output.employee = await reviews.getEmployee({
      transaction,
    });

    output.reviewer = await reviews.getReviewer({
      transaction,
    });

    output.organizations = await reviews.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.review_cycles,
        as: 'review_cycle',

        where: filter.review_cycle
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.review_cycle
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.review_cycle
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.employees,
        as: 'reviewer',

        where: filter.reviewer
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reviewer
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.reviewer
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.comments) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('reviews', 'comments', filter.comments),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.reviews.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('reviews', 'review_cycle', query),
        ],
      };
    }

    const records = await db.reviews.findAll({
      attributes: ['id', 'review_cycle'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['review_cycle', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.review_cycle,
    }));
  }
};
